/* gtkGL
 * Copyright (C) 1997,1998 AOSASA Shigeru
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the 
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
#ifndef __GTK_GL_UTILS_H__
#define __GTK_GL_UTILS_H__


#include <gdkGL/gdkGL.h>
#include <gtkGL/gtkGLcontext.h>


#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


void  gtk_gl_push_context         (GtkGLContext *context);
void  gtk_gl_pop_context          (void);

gint  gtk_gl_wrap_begin           (GtkGLContext *context,
				   gint          nest);
gint  gtk_gl_wrap_end             (GtkGLContext *context,
				   gint          nest);
gint  gtk_gl_wrap_begin_strict    (GtkGLContext *context,
				   gint          nest);
gint  gtk_gl_wrap_end_strict      (GtkGLContext *context,
				   gint          nest);
gint  gtk_gl_wrap_begin_defaults  (gint          nest);
gint  gtk_gl_wrap_end_defaults    (gint          nest);



#define GTK_GL_WRAP(context, gl_action)			   G_STMT_START{\
     if (gtk_gl_wrap_begin_strict (context, FALSE) == TRUE)		\
       {								\
	 gl_action;							\
	 gtk_gl_wrap_end_strict (context, FALSE);			\
       }						   }G_STMT_END

#define GTK_GL_NEST_WRAP(context, gl_action)		   G_STMT_START{\
     if (gtk_gl_wrap_begin_strict (context, TRUE) == TRUE)		\
       {								\
	 gl_action;							\
	 gtk_gl_wrap_end_strict (context, TRUE);			\
       }						   }G_STMT_END

#define GTK_GL_WRAP_DEFAULTS(gl_action)			   G_STMT_START{\
     if (gtk_gl_wrap_begin_defaults (FALSE) == TRUE)			\
       {								\
	 gl_action;							\
	 gtk_gl_wrap_end_defaults (FALSE);				\
       }						   }G_STMT_END

#define GTK_GL_NEST_WRAP_DEFAULTS(gl_action)		   G_STMT_START{\
     if (gtk_gl_wrap_begin_defaults (TRUE) == TRUE)			\
       {								\
	 gl_action;							\
	 gtk_gl_wrap_end_defaults (TRUE);				\
       }						   }G_STMT_END


#define GTK_GL_WRAP_BEGIN(context)					\
     {									\
       if (gtk_gl_wrap_begin (context, FALSE) != TRUE)			\
	 {								\
	   g_warning ("GTK_GL_WRAP_BEGIN failed\n");			\
	 }								\
       else								\
	 {
#define GTK_GL_WRAP_END							\
	   gtk_gl_wrap_end (NULL, FALSE);				\
	 }								\
     }

#define GTK_GL_NEST_WRAP_BEGIN(context)					\
     {									\
       if (gtk_gl_wrap_begin (context, TRUE) != TRUE)			\
	 {								\
	   g_warning ("GTK_GL_NEST_WRAP_BEGIN failed\n");		\
	 }								\
       else								\
	 {
#define GTK_GL_NEST_WRAP_END						\
	   gtk_gl_wrap_end (NULL, TRUE);				\
	 }								\
     }

#define GTK_GL_WRAP_BEGIN_STRICT(context)				\
     {									\
       if (gtk_gl_wrap_begin_strict (context, FALSE) != TRUE)		\
	 {								\
	   g_warning ("GTK_GL_WRAP_BEGIN_STRICT failed\n");		\
	 }								\
       else								\
	 {
#define GTK_GL_WRAP_END_STRICT(context)					\
	   gtk_gl_wrap_end_strict (context, FALSE);			\
	 }								\
     }

#define GTK_GL_NEST_WRAP_BEGIN_STRICT(context)				\
     {									\
       if (gtk_gl_wrap_begin_strict (context, TRUE) != TRUE)		\
	 {								\
	   g_warning ("GTK_GL_NEST_WRAP_BEGIN_STRICT failed\n");	\
	 }								\
       else								\
	 {
#define GTK_GL_NEST_WRAP_END_STRICT(context)				\
	   gtk_gl_wrap_end_strict (context, TRUE);			\
	 }								\
     }

#define GTK_GL_WRAP_BEGIN_DEFAULTS					\
     {									\
       if (gtk_gl_wrap_begin_defaults (FALSE) != TRUE)			\
	 {								\
	   g_warning ("GTK_GL_WRAP_BEGIN_DEFAULTS failed\n");		\
	 }								\
       else								\
	 {
#define GTK_GL_WRAP_END_DEFAULTS					\
	   gtk_gl_wrap_end_defaults (FALSE);				\
	 }								\
     }

#define GTK_GL_NEST_WRAP_BEGIN_DEFAULTS					\
     {									\
       if (gtk_gl_wrap_begin_defaults (TRUE) != TRUE)			\
	 {								\
	   g_warning ("GTK_GL_NEST_WRAP_BEGIN_DEFAULTS failed\n");	\
	 }								\
       else								\
	 {
#define GTK_GL_NEST_WRAP_END_DEFAULTS					\
	   gtk_gl_wrap_end_defaults (TRUE);				\
	 }								\
     }


#ifdef __cplusplus
}
#endif /* __cplusplus */


#endif /* __GTK_GL_UTILS_H__ */
